#include "element.h"

void Element::
compute(float youngs_modulus, float poisson_ratio, const Vec2f &restx1, const Vec2f &restx2, const Vec2f &restx3)
{
   //@@@ Compute and store the element stiffness matrix (a 6x6 matrix) in K.
   //@@@ This assumes linear elasticity, discretized with FEM using piecewise linear triangle basis functions.
   //@@@ Work out (or find---making sure to cite your resource) the formula for this matrix.
}

void Element::
apply_elastic(const Vec2f &d1, const Vec2f &d2, const Vec2f &d3, Vec2f &f1, Vec2f &f2, Vec2f &f3) const
{
   f1[0]=K(0,0)*d1[0] + K(0,1)*d1[1] + K(0,2)*d2[0] + K(0,3)*d2[1] + K(0,4)*d3[0] + K(0,5)*d3[1];
   f1[1]=K(1,0)*d1[0] + K(1,1)*d1[1] + K(1,2)*d2[0] + K(1,3)*d2[1] + K(1,4)*d3[0] + K(1,5)*d3[1];
   f2[0]=K(2,0)*d1[0] + K(2,1)*d1[1] + K(2,2)*d2[0] + K(2,3)*d2[1] + K(2,4)*d3[0] + K(2,5)*d3[1];
   f2[1]=K(3,0)*d1[0] + K(3,1)*d1[1] + K(3,2)*d2[0] + K(3,3)*d2[1] + K(3,4)*d3[0] + K(3,5)*d3[1];
   f3[0]=K(4,0)*d1[0] + K(4,1)*d1[1] + K(4,2)*d2[0] + K(4,3)*d2[1] + K(4,4)*d3[0] + K(4,5)*d3[1];
   f3[1]=K(5,0)*d1[0] + K(5,1)*d1[1] + K(5,2)*d2[0] + K(5,3)*d2[1] + K(5,4)*d3[0] + K(5,5)*d3[1];
}

void Element::
apply_damping(const Vec2f &v1, const Vec2f &v2, const Vec2f &v3, Vec2f &f1, Vec2f &f2, Vec2f &f3) const
{
   apply_elastic(v1, v2, v3, f1, f2, f3);
   f1*=damping_ratio;
   f2*=damping_ratio;
   f3*=damping_ratio;
}

void polar_rotation(const Vec2f &restx1, const Vec2f &restx2, const Vec2f &restx3,
                    const Vec2f &x1, const Vec2f &x2, const Vec2f &x3, float &cosine, float &sine)
{
   //@@@ Figure out the signed polar decomposition for the current configuration of a triangle
   //@@@ Figuring out how to do this is one of the assignment questions
}

