#include "simulation.h"

void Simulation::
advance(float dt)
{
   unsigned int i;
   for(i=0; i<object.size(); ++i){
      // save where it now for later collision processing
      object[i].save_positions();
      // take small substeps to get to the end of the collision step
      float t=0;
      bool done=false;
      while(!done){
	 float subdt=object[i].maxdt;
	 if(t+subdt>=dt){
	    done=true;
	    subdt=dt-t;
	 }else if(t+1.5*subdt>dt)
	    subdt=0.5*(dt-t);
         object[i].advance(subdt);
	 t+=subdt;
      }
   }
   collisions.resolve_all_collisions(object);
}

